image: docker:latest
services: 
  - docker:dind

build:
  stage: build
  script:
    - docker login -u $CI_REGISTRY_USER -p  $CI_REGISTRY_PASSWORD
    - docker pull $CI_REGISTRY_IMAGE:latest || true
    - docker build --cache-from $CI_REGISTRY_IMAGE:latest --tag $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA --tag $CI_REGISTRY_IMAGE:latest .

deploy:
   stage: deploy
   script:
    - docker login -u $CI_REGISTRY_USER -p  $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
    - docker push $CI_REGISTRY_IMAGE:latest
   only:
    - master
